--[[ 
	Thanks at skyboat for the original addon!
--]]

----------------------------
--      Declaration       --
----------------------------

Reslack = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0")

----------------------------
--      Main Functions    --
----------------------------

local defaults = {
	AcceptResurrect = true,
	AcceptSummon = false,
	AcceptReady = false,
	notice = false
}

function Reslack:OnInitialize()
	self.options = {
		type="group",
		args = {
			resurrect = {
				name =	"Resurrect", type = "toggle",
				desc =	"Toggle the auto-resurrect function",
				get =	function()
							return self.db.profile.AcceptResurrect
						end,
						set = function(v)
							self.db.profile.AcceptResurrect = v
						end,
			},
			summon = {
				name =	"Summon", type = "toggle",
				desc =	"Toggle the auto-summon function",
				get =	function()
							return self.db.profile.AcceptSummon
						end,
						set = function(v)
							self.db.profile.AcceptSummon = v
						end,
			},
			ready = {
				name =	"Ready", type = "toggle",
				desc =	"Toggle the auto-ready function",
				get =	function()
							return self.db.profile.AcceptReady
						end,
						set = function(v)
							self.db.profile.AcceptReady = v
						end,
			},
			notice = {
				name =	"Notice", type = "toggle",
				desc =	"Toggle notices to player",
				get =	function()
							return self.db.profile.notice
						end,
						set = function(v)
							self.db.profile.notice = v
						end,
			},
		},
	}
	
	-- Register everything
	self:RegisterDB("ReslackDB")
	self:RegisterDefaults('profile', defaults)
	self:RegisterChatCommand({ "/reslack", "/res" }, self.options )
end

function Reslack:OnEnable()
	self:RegisterEvent("RESURRECT_REQUEST", "Resurrect")
	self:RegisterEvent("CONFIRM_SUMMON", "Summon")
	self:RegisterEvent("READY_CHECK", "Ready")
end

function Reslack:OnDisable()
	self:UnregisterAllEvents()
end

function Reslack:Resurrect()
	if not self.db.profile.AcceptResurrect then return end
	if (GetCorpseRecoveryDelay() == 0) then
		getglobal("StaticPopup1"):Hide()
		AcceptResurrect()
		if self.db.profile.notice then self:Print("Ressurection confirmed!") end
	else
		self:ScheduleEvent(function() getglobal("StaticPopup1"):Hide() AcceptResurrect() if self.db.profile.notice then self:Print("Ressurection confirmed!") end end, GetCorpseRecoveryDelay()+5)
	end
end

function Reslack:Summon()
	if not self.db.profile.AcceptSummon then return end
	if (not UnitAffectingCombat("player")) then
		getglobal("StaticPopup1"):Hide()
		ConfirmSummon()
		if self.db.profile.notice then self:Print("Summon confirmed!") end
	end
end

function Reslack:Ready()
	if not self.db.profile.AcceptReady then return end
	ReadyCheckFrame:Hide()
	ConfirmReadyCheck(1)
	if self.db.profile.notice then self:Print("Ready check confirmed!") end
end
